<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>polylib: disjoint_union_adj.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.6 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
<h1>disjoint_union_adj.c</h1><a href="disjoint__union__adj_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*       Polyhedron disjoint intersections</span>
<a name="l00002"></a>00002 <span class="comment"> */</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">/*</span>
<a name="l00005"></a>00005 <span class="comment"> disjoint_union_adj computes the disjoint union of the given list of domains.</span>
<a name="l00006"></a>00006 <span class="comment"> input:</span>
<a name="l00007"></a>00007 <span class="comment">    (integer) # of polyhedra</span>
<a name="l00008"></a>00008 <span class="comment">    list of polyhedra in the usual matrix (constraints) format</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment"> output:</span>
<a name="l00011"></a>00011 <span class="comment">    list of polyhedra (constraint matrices) having their facets in common</span>
<a name="l00012"></a>00012 <span class="comment"></span>
<a name="l00013"></a>00013 <span class="comment">*/</span>
<a name="l00014"></a>00014 
<a name="l00015"></a>00015 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00016"></a>00016 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00019"></a>00019 
<a name="l00020"></a><a class="code" href="disjoint__union__adj_8c.html#59799636dce6e7dfa2ce20c48147fa6b">00020</a> <span class="preprocessor">#define WS 0</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">/* Procedure to print constraints of a domain */</span>
<a name="l00024"></a><a class="code" href="disjoint__union__adj_8c.html#51b38b45c0f9368ca2156de51ee8404e">00024</a> <span class="keywordtype">void</span> <a class="code" href="disjoint__union__adj_8c.html#51b38b45c0f9368ca2156de51ee8404e">AffContraintes</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="vector_8c.html#a45b2e3dcf291527c5aedc420819adfc">p</a>)
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026         <span class="keywordflow">for</span>( ;p;p=p-&gt;<a class="code" href="structpolyhedron.html#ab97126cb9e56431d40eaf4e68b3953d">next</a>)
<a name="l00027"></a>00027         {
<a name="l00028"></a>00028                 <a class="code" href="polyhedron_8c.html#2303f014f8cd948a950c920085135081">Polyhedron_PrintConstraints</a>(stdout, <a class="code" href="types_8h.html#e6f16bcd4a42ba51cbb003e3d1e1cde6">P_VALUE_FMT</a>, p );
<a name="l00029"></a>00029                 printf(<span class="stringliteral">"\n"</span>);
<a name="l00030"></a>00030         }
<a name="l00031"></a>00031 }
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a><a class="code" href="disjoint__union__adj_8c.html#e66f6b31b5ad750f1fe042a706a4e3d4">00034</a> <span class="keywordtype">int</span> <a class="code" href="c2p_8c.html#e66f6b31b5ad750f1fe042a706a4e3d4">main</a>() {
<a name="l00035"></a>00035   
<a name="l00036"></a>00036         <span class="keywordtype">int</span> np, i;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038         <a class="code" href="structmatrix.html">Matrix</a> *a;
<a name="l00039"></a>00039         <a class="code" href="structpolyhedron.html">Polyhedron</a> *A, *tmp, *DD;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041         scanf( <span class="stringliteral">"%d"</span>, &amp;np );
<a name="l00042"></a>00042 
<a name="l00043"></a>00043         A = NULL;
<a name="l00044"></a>00044         <span class="keywordflow">for</span>( i=0 ; i&lt;np ; i++ )
<a name="l00045"></a>00045         {
<a name="l00046"></a>00046                 a = <a class="code" href="matrix_8c.html#3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00047"></a>00047                 tmp = <a class="code" href="polyhedron_8c.html#efb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(a,<a class="code" href="ext__ehrhart_8c.html#59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00048"></a>00048                 <a class="code" href="matrix_8c.html#fcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(a);
<a name="l00049"></a>00049                 tmp -&gt;<a class="code" href="structpolyhedron.html#ab97126cb9e56431d40eaf4e68b3953d">next</a> = A;
<a name="l00050"></a>00050                 A = tmp;
<a name="l00051"></a>00051         }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054         DD = <a class="code" href="polyhedron_8c.html#a2db71a574d8c1b1c3d90df140f1e5fd">Disjoint_Domain</a>( A, 1, <a class="code" href="ext__ehrhart_8c.html#59799636dce6e7dfa2ce20c48147fa6b">WS</a> );
<a name="l00055"></a>00055 
<a name="l00056"></a>00056         <a class="code" href="disjoint__union__adj_8c.html#51b38b45c0f9368ca2156de51ee8404e">AffContraintes</a>(DD);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <span class="keywordflow">return</span> 0;
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 15 18:33:58 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.6 </small></address>
</body>
</html>
